Introduction
************

The Audio toolkit is a set of functions for manipulating MIDI devices
and files for GNU Octave

1 Installing and loading
************************

The Audio toolkit must be installed and then loaded to be used.

It can be installed in GNU Octave directly from octave-forge, or can be
installed in an off-line mode via a downloaded tarball.

The toolkit has a dependency on the RTMIDI library
(<https://github.com/thestk/rtmidi>), so it must be installed in order
to successfully install the toolkit.

For Fedora: ‘yum install rtmidi-devel’

For Ubuntu: ‘apt install librtmidi-dev’

The toolkit must be then be loaded once per each GNU Octave session in
order to use its functionality.

1.1 Windows install
===================

If running in Windows, the package may already be installed, to check
run:

     pkg list audio

Otherwise it can be installed by installing the requirements and then
using the online or offline install method.

1.2 Online Direct install
=========================

With an internet connection available, the Audio package can be
installed from octave-forge using the following command within GNU
Octave:

     pkg install -forge audio

The latest released version of the toolkit will be downloaded and
installed.

1.3 Off-line install
====================

With the Audio toolkit package already downloaded, and in the current
directory when running GNU Octave, the package can be installed using
the following command within GNU Octave:

     pkg install audio-2.0.9.tar.gz

1.4 Loading
===========

Regardless of the method of installing the Audio toolkit, in order to
use its functions, the toolkit must be loaded using the pkg load
command:

     pkg load audio

The toolkit must be loaded on each GNU Octave session.

2 Basic Usage Overview
**********************

The Audio package must be loaded each time a GNU Octave session is
started:
     pkg load audio

An overview of the package can be displayed by running ‘help audio’

Help for each function can be displayed by ‘help thefunctionname’

ie:
     help mididevice

2.1 Conversion Functionality
============================

The following functions are available to convert between audio domains:
hz2erb, erb2hz
     Conversion between hz and equivalent rectangular bandwidths (ERP)
     frequency scales
hz2mel, mel2hz
     Conversion between hz and equivalent mel frequency scales
hz2bark, bark2hz
     Conversion between hz and equivalent bark frequency scales
phon2sone, sone2phone
     Conversion between sone and phon loudness scales

2.2 Waveform Generation
=======================

The ‘audioOscillator’ function provides a method of creating a waveform
generator for sine, square and sawtooth waveforms.

     % create a sawtooth audio generator
     osc = audioOscillator("sawtooth");
     % get a frame of data
     data = osc();
     % plot the data
     plot(data);

2.3 MIDI Functionality
======================

The Audio toolkit provides 3 main types of MIDI functionality:

Device functions
     These are functions that directly allow opening, sending and
     receiving MIDI messages.
Controller functions
     Functions that provide a layer on top of the device functions for
     using MIDI controls.
File functions
     Basic functions that allow read and write of MIDI files.

To read and write to a MIDI device, a MIDI device object must be
created, using the name or id of a known MIDI device as provided by the
mididevinfo function.

MIDI devices can then be read using the midisend and midireceive
functions that use midimsg type to encapsulate the MIDI data.

     % list the midi devices
     devs = mididevinfo

     % open a midi device, specifying the first input and output MIDI device
     dev = mididevice("input", devs.input{1}.ID, "output", devs.output{1}.ID)

     % receive data and echo it through the output port
     while true
       msg = midireceive(dev, 1);
       if !isempty(msg)
         midisend(msg);
       endif
     endwhile

3 Function Reference
********************

The functions currently available in the Audio toolkit are described
below:

3.1 MIDI Device Interface
=========================

3.1.1 @octave_midi/hasdata
--------------------------

 -- : TF = hasdata (DEV)
     Return whether there is data available to read

     Inputs
     ......

     DEV - a octave midi device opened using mididevice.

     Outputs
     .......

     TF - true if device has data available to read

     See also: mididevice.

3.1.2 mididevice
----------------

 -- : DEV = mididevice (MIDIDEV)
 -- : DEV = mididevice (MIDIDIR, MIDIDEV)
 -- : DEV = mididevice ("input", MIDIINDEV, "output", MIDIOUTDEV)
     Create a midi device using the input parameters.

     When a single device name or id is provided, attempt to create the
     midi device using the same name for both input and output.

     Otherwise, use the name or device id for the given input or output
     direction.

     Inputs
     ......

     MIDIDEV - name or id of device to load.
     MIDIDIR - midi direction of "input" or "output"
     MIDIINDEV - midi input name or id
     MIDIOUTDEV - midi output name or id

     Outputs
     .......

     DEV - octave_midi class for opened device

     Properties
     ..........

     INPUT - Input device name (read only).
     OUTPUT - Output device name (read only).
     INPUTID - Input device id (read only).
     OUTPUTID - Output device id (read only).

     Examples
     ........

     Open midi device with ID of 0.
          > dev = mididevice(0);

            mididevice connected to
              input: "SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0" (1)
              output: "SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0" (0)

     Open a named midi device:
          > dev = mididevice("SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0");

            mididevice connected to
              input: "SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0" (1)
              output: "SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0" (0)

     See also: mididevinfo.

3.1.3 mididevinfo
-----------------

 -- : DEVLIST = mididevinfo ()
 -- : mididevinfo ()
     Retrieve the midi devices detected within the system.

     The list will be stored with variable DEVLIST as either a input or
     output device.  If no output variable is provided, the devices will
     be displayed.

     Inputs
     ......

     None

     Outputs
     .......

     DEVLIST - a structure containing the midi device information

     Examples
     ........

     Display the known devices of the system.
          > mididevinfo

           MIDI devices available
           ID Direction Interface  Name
            0 output    Alsa       Midi Through:Midi Through Port-0 14:0
            1 output    Alsa       Ensoniq AudioPCI:ES1371 16:0
            2 output    Alsa       SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0
            3 input     Alsa       Midi Through:Midi Through Port-0 14:0
            4 input     Alsa       Ensoniq AudioPCI:ES1371 16:0
            5 input     Alsa       SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0

     Assign variable MIDIDEVICES with the values from the known devices
          > mididevices = mididevinfo

           mididevices =
            scalar structure containing the fields:
              input =
              {
                [1,1] =
                  scalar structure containing the fields:
                    Name = SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0
                    Interface = Alsa
                    ID =  0
              }
              output =
              {
                [1,1] =
                  scalar structure containing the fields:
                    Name = SparkFun Pro Micro:SparkFun Pro Micro MIDI 1 20:0
                    Interface = Alsa
                    ID =  1
              }

     See also: mididevice.

3.1.4 midiflush
---------------

 -- : midiflush (DEV)
     Flush the receive buffers on a midi device

     Inputs
     ......

     DEV - midi device opened using mididevice

     Outputs
     .......

     None

     Examples
     ........

     Flush a midi device
           midiflush(dev);

     See also: mididevice, midireceive.

3.1.5 midimsg
-------------

 -- : MSG = midimsg (0)
 -- : MSG = midimsg (TYPE ....)
 -- : MSG = midimsg ("note", CHANNEL, NOTE, VELOCITY, DURATION,
          TIMESTAMP)
 -- : MSG = midimsg ("noteon", CHANNEL, NOTE, VELOCITY, TIMESTAMP)
 -- : MSG = midimsg ("noteoff", CHANNEL, NOTE, VELOCITY, TIMESTAMP)
 -- : MSG = midimsg ("programchange", CHANNEL, PROG, TIMESTAMP)
 -- : MSG = midimsg ("controlchange", CHANNEL, CCNUM, CCVAL, TIMESTAMP)
 -- : MSG = midimsg ("polykeypressure", CHANNEL, NOTE, KEYPRESSURE,
          TIMESTAMP)
 -- : MSG = midimsg ("channelpressure", CHANNEL, CHANPRESSURE,
          TIMESTAMP)
 -- : MSG = midimsg ("localcontrol", CHANNEL, LOCALCONTROL, TIMESTAMP)
 -- : MSG = midimsg ("pitchbend", CHANNEL, PITCHCHANGE, TIMESTAMP)
 -- : MSG = midimsg ("polyon", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("monoon", CHANNEL, MONOCHANNELS, TIMESTAMP)
 -- : MSG = midimsg ("omnion", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("omnioff", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("allsoundoff", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("allnotesoff", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("resetallcontrollers", CHANNEL, TIMESTAMP)
 -- : MSG = midimsg ("start", TIMESTAMP)
 -- : MSG = midimsg ("stop", TIMESTAMP)
 -- : MSG = midimsg ("continue", TIMESTAMP)
 -- : MSG = midimsg ("systemreset", TIMESTAMP)
 -- : MSG = midimsg ("activesensing", TIMESTAMP)
 -- : MSG = midimsg ("timingclock", TIMESTAMP)
 -- : MSG = midimsg ("systemexclusive", TIMESTAMP)
 -- : MSG = midimsg ("systemexclusive", BYTES, TIMESTAMP)
 -- : MSG = midimsg ("eox", TIMESTAMP)
 -- : MSG = midimsg ("data", BYTES, TIMESTAMP)
 -- : MSG = midimsg ("songselect", SONG, TIMESTAMP)
 -- : MSG = midimsg ("songpositionpointer", SONGPOSITION, TIMESTAMP)
 -- : MSG = midimsg ("tunerequest", TIMESTAMP)
 -- : MSG = midimsg ("miditimecodequarterframe", TIMESEQ, TIMEVALUE,
          TIMESTAMP)
     Create a midimsg object

     If the input parameter is 0, create an empty midi message object
     Otherwise the first variable is the type of message to create,
     followed by the additional parameters for the message.

     For each message type, the timestamp value is optional.

     Inputs
     ......

     TYPE - string message type or a midimsgtype.
     TIMESTAMP - optional seconds time stamp for the event
     CHANNEL - the channel to use for the message (1..16)
     NOTE - the value of the note to play/stop
     VELOCITY - the velocity value for a note on/off, with 0 stopping a
     note from sounding.
     DURATION - seconds between starting and stopping a note when
     created a 'note' message.
     PROG - program number when doing a program change message.
     CCNUM - control change control number.
     CCVAL - control change control value.
     KEYPRESSURE - key pressure value when creating a key pressure
     message.
     CHANPRESSURE - channel pressure value when creating a
     channelpressure message.
     PITCHCHANGE - pitch change value when creating a pitch bend
     message.
     LOCALCONTROL - boolean value when creating a localcontrol message.
     MONOCHANNELS - channels specified for a mono on message.
     BYTES - array of data in range of 0 to 127 specified as part of a
     data message or system exclusive message.
     SONG - song selection number for a song selection message.
     SONGPOSITION - song position value for a song position message.
     TIMESEQ - timecode sequence number for a miditimecodequarterframe
     message.
     TIMEVALUE - timecode value number for a miditimecodequarterframe
     message.

     Outputs
     .......

     MSG - a midimsg object containing the midi data of the message

     Properties
     ..........

     TIMESTAMP - timestamp of the message, or an array or timestamps if
     the the message is a compound message.
     MSGBYTES - the raw message bytes that make up the MIDI message.
     NUMMSGBYTES - the number of message bytes that make up the MIDI
     message.
     TYPE - string or midimsgtype that represents the message type.
     CHANNEL - the channel number for message.
     NOTE - the note value for message (Only valid for noteon/off and
     polykeypressure).
     VELOCITY - the velocity value for message (Only valid for
     noteon/off).
     KEYPRESSURE - the keypressure value for message (Only valid for
     polykeypressure).
     CHANNELPRESSURE - the chanpressure value for message (Only valid
     for channelpressure).
     LOCALCONTROL - the localcontrol value for message (Only valid for
     localcontrol messages).
     MONOCHANNELS - channels specified for a mono on message.
     PROGRAM - program number specified for a program change message.
     CCNUMBER - control change number specified for a control change
     message.
     CCVALUE - control change value specified for a control change
     message.
     SONG - song number for a song selection message.
     SONGPOSITION - song position value for a song position message.
     PITCHCHANGE - pitch change value for a pitch bend message.
     TIMECODESEQUENCE - timecode sequence number for a
     miditimecodequarterframe message.
     TIMECODEVALUE - timecode value number for a
     miditimecodequarterframe message.

     Examples
     ........

     Create a note on/off pair with a duration of 1.5 seconds
           msg = midimsg('note', 1, 60, 100, 1.5)

     Create a separate note on/off pair with a time between them of 1.5
     seconds
           msg = [midimsg('noteon', 1, 60, 100, 0), midimsg('noteoff', 1, 60, 0, 1.5)]

     Create a system reset message
           msg = midimsg('systemreset')

     See also: midifileread, midisend, midireceive, midimsgtype.

3.1.6 midireceive
-----------------

 -- : MIDIMSG = midireceive (DEV)
 -- : MIDIMSG = midireceive (DEV, MAXMSG)
     Attempt to receive midi messages from a midi device.

     Inputs
     ......

     DEV - a octave midi device opened using mididevice.
     MAXMSG - Maximum number of messages to retrieve.  If not specified,
     the function will attempt to get all pending.

     Outputs
     .......

     MIDIMSG - a midimsg containing the messages retrieved from the
     device.
     If no messages are available, MIDIMSG will be empty.

     Examples
     ........

     Open device 0, and poll and display read messages
           dev = mididevice(0);
           while true
              mx = midireceive(dev);
              if !isempty(mx)
                % display message
                mx
              endif
           endwhile

     See also: mididevice, midisend.

3.1.7 midisend
--------------

 -- : midisend (DEV, MSG)
 -- : midisend (DEV, ...)
     Send a midimsg to a midi device

     Inputs
     ......

     DEV - midi device opened using mididevice
     MSG - a midi message class with messages to send to the midi device
     If the msg isn't a midimsg class, the input data is expected to be
     in same format as the inputs to a midimsg object.

     Outputs
     .......

     None

     Examples
     ........

     Send a note on/off command to a opened midi device DEV
           midisend(dev, midimsg("note", 1, 60, 100, 2.0));

     See also: midimsg, mididevice, midireceive.

3.2 MIDI Controller Interface
=============================

3.2.1 midicallback
------------------

 -- : OLDHANDLE = midicallback (MIDICONTROLSOBJ, FUNCTIONHANDLE)
 -- : OLDHANDLE = midicallback (MIDICONTROLSOBJ, [])
 -- : CURRHANDLE = midicallback (MIDICONTROLSOBJ)
     Get, set or clear the midicontrol object callback.

     Inputs
     ......

     MIDICONTROLOBJ - control object created using midicontrols.

     FUNCTIONHANDLE - function handle to set for call back.  If it is
     [], the callback function will be cleared.

     *NOTE*: currently anonymous functions will not work.

     *NOTE*: callbacks should be cleared before losing all references to
     the midicontrols object.

     Outputs
     .......

     OLDHANDLE The previously set midicallback function handle when
     setting a new callback.

     CURRHANDLE The current set midicallback function handle.

     Examples
     ........

     Set a callback on a midicontrols object
           ctrl = midicontrols(2001)
           function dispCallback(ctrl),disp(midiread(ctrl)),endfunction;
           midicallback(ctrl, @dispCallback);

     Clear the callback on a midicontrols object
           ctrl = midicontrols(2001)
           midicallback(ctrl, []);

     Get the current callback on a midicontrols object
           ctrl = midicontrols(2001)
           cb = midicallback(ctrl);

     See also: midicontrols, midisync, midiread.

3.2.2 midicontrols
------------------

 -- : OBJ = midicontrols ()
 -- : OBJ = midicontrols (CTRLID)
 -- : OBJ = midicontrols (CTRLID, INITIALVALUES)
 -- : OBJ = midicontrols (__, PROPERTYNAME, PROPERTYVALUE)
     Create a midi controls object

     Inputs
     ......

     CTRLID - single control id or array of control ids to monitor, or
     [] to use any controller.
     INITIALVALUES - initial values to use for controls.  It should be
     the same size as CTRLID
     PROPERTYNAME, PROPERTYVALUE - properties to set on the controller.
     If a device is not specified the value from getpref("midi",
     "DefaultDevice", 0) will be used.

     Known properties are:
     mididevice
          name of the mididevice to monitor.
     outputmode
          the scaling mode for values: 'rawmidi' will return values
          between 0 ..  127, 'normalized' will use values between 0 ..
          1.

     Outputs
     .......

     OBJ - returns a midicontrols object

     Examples
     ........

     Create a midicontrols object monitoring control id 2001 on the
     default midi device
           ctrl = midicontrols(2001)

     Create a midicontrols object monitoring control id 2001 on a a non
     default device
           ctrl = midicontrols(2001, 'mididevice', 1)

     See also: midiread, midisync.

3.2.3 midiid
------------

 -- : [CTRLID, DEV] = midiid ()
     Scan for control messages from midi devices to get the id of the
     device

     Function will display a prompt for the user to move the midi
     control and return when a control messages is detected or ctrl-C is
     pressed.

     Inputs
     ......

     None

     Outputs
     .......

     CTRLID - control id made from the controller channel * 1000 +
     controller number.
     DEV = name of the midi device the controller was detected on.

     Examples
     ........

     Monitor midi devices for first moving controller
           [ctrlid, devname] = midiid()

     See also: mididevinfo, midicontrols.

3.2.4 midiread
--------------

 -- : VAL = midiread (MIDICONTROLSOBJ)
     Read current values of midi controls

     Inputs
     ......

     MIDICONTROLOBJ - control object created using midicontrols

     Outputs
     .......

     VAL single value or array of current values from the midi device.

     Examples
     ........

     Read current value of midicontrols with a ctrlid 2001 on the
     default midi device.
           ctrl = midicontrols(2001)
           val = midiread(ctrl);

     Read current value of midicontrols with a ctrlid 2001 on a non
     default midi device.
           ctrl = midicontrols(2001, 'mididevice', 1)
           val = midiread(ctrl);

     See also: midicontrols, midisync.

3.2.5 midisync
--------------

 -- : midisync (MIDICONTROLSOBJ)
 -- : midisync (MIDICONTROLSOBJ, CTRLVALUES)
     Send the values of control object to the control, using CTRLVALUES
     values if specified instead

     Inputs
     ......

     MIDICONTROLOBJ - control object created using midicontrols
     CTRLVALUES - values to send to the controls instead of initial
     values

     Outputs
     .......

     None

     Examples
     ........

     Send sync command to a midicontrols with a ctrlid 2001 to set a
     value of 1
           ctrl = midicontrols(2001)
           midisync(ctrl, 1);

     See also: midicontrols.

3.3 MIDI File I/O
=================

3.3.1 ismidifile
----------------

 -- : ISMIDI = ismidifile (FILENAME)
     Check if FILENAME is a midi file.

     The function only checks whether it is an existing file and the
     file starts with a valid 'MThd' header.

     Non existing files, or files that do not meet the header criteria
     will return false.

     Inputs
     ......

     FILENAME - filename of file to check.

     Outputs
     .......

     ISMIDI - true if it is a midi file, false otherwise

     See also: midifileread, midifilewrite.

3.3.2 midifileinfo
------------------

 -- : INFO = midifileinfo (FILENAME)
     Read MIDI file and display information about the tracks and data

     Inputs
     ......

     FILENAME - filename of file to open.

     Outputs
     .......

     INFO - structure of the midi file data with the following fields:
     filename
          the name of the file
     header
          The header block information
     track
          An array of tracks read from the file
     other
          An array of non-track midi blocks read from the file

     See also: midifileread.

3.3.3 midifileread
------------------

 -- : MSG = midifileread (FILENAME, [propertyname, propertyvalue ...])
     Read MIDI file into a midimsg

     Inputs
     ......

     FILENAME - filename of file to open.
     PROPERTYNAME, PROPERYVALUE - optional propertyname/value pairs.

     Known property values are:
     includemetaevents
          A True/False value to include MetaEvents in the out message
          list.

     Outputs
     .......

     MSG - a midimsg struct containing the messages read from the file

     See also: midifileinfo, midimsg.

3.3.4 midifilewrite
-------------------

 -- : midifilewrite (FILENAME, MSGS)
 -- : midifilewrite (FILENAME, MSGS, OPTIONNAME, OPTIONVALUE)
     Write a midifile

     Inputs
     ......

     FILENAME - filename of file to open.
     MSG - a midimsg struct or a cell array of midimsg containing data
     to write to file
     OPTIONNAME, OPTIONVALUE - option value/name pairs

     Known options are:
     format
          MIDI file format number.  (0 (default), 1, 2)

     Where format is 0, if a cell array is passed to midifilewrite, the
     midimsg values will be concatenated together before saving.

     Were format is not 0, the cell array is treated as tracks of
     misimsg.

     Outputs
     .......

     None

     See also: midifileread, midimsg.

3.4 Enumerations
================

3.4.1 midimsgtype
-----------------

 -- : midimsgtype
     A midimsg type enumeration for values of the midimsg type.

     Enumeration values are:
     Data           Stop                          SongPositionPointer
     PolyOn         PolyKeyPressure               NoteOff
     EOX            ActiveSensing                 SongSelect
     MonoOn         ChannelPressure               ControlChange
     TimingClock    SystemReset                   AllSoundOff
     OmniOn         PitchBend                     ProgramChange
     Start          TuneRequest                   ResetAllControllers
     OmniOff        Undefined                     SystemExclusive
     Continue       MIDITimeCodeQuarterFrame      LocalControl
     AllNotesOff    MetaEvent

     The enumeration value can be used instead of a string in midimsg
     creation.

     Examples
     ........

     Use both a string and a midimsgtype for the type parameter of a
     midimsg.

           # both statements are equivalent
           msg = midimsg('NoteOn', 1, 60, 100);
           msg = midimsg(midimsgtype.NoteOn, 1, 60, 100);

     See also: midimsg.

3.5 Waveform Generation
=======================

3.5.1 audioOscillator
---------------------

 -- : audioOscillator
     Generate sine, sawtool and square waveforms

Methods
-------

 -- : OBJ = audioOscillator ()
 -- : OBJ = audioOscillator (SIGNALTYPEVALUE)
 -- : OBJ = audioOscillator (SIGNALTYPEVALUE, FREQUENCYVALUE)
 -- : OBJ = audioOscillator (__, PROPERTYNAME, PROPERTYVALUE)
     Create a audioOscillator object

     Inputs
     ......

     SIGNALTYPEVALUE - signal type of "sine" (default), "square",
     "sawtooth".
     FREQUENCYVALUE - hz frequency value of waveform (default 100).
     PROPERTYNAME, PROPERTYVALUE - properties to set on the object.

     Known properties are:
     SignalType
          signal type of "sine" (default), "square" or "sawtooth".
          (readonly)
     Frequency
          frequency of the waveform (default 100)
     Amplitude
          amplitude of the signal (default 1)
     SampleRate
          sample rate of the signal (default 44100)
     PhaseOffset
          phase offset of signal 0 (default) - 1 (readonly)
     DutyCycle
          dutycycle of the signal 0 - 1 (default 0.5) when signal is a
          square wave.
     SamplePerFrame
          Samples per frame as returned from () (default 512)
     MaxSamplePerFrame
          Max samples per frame (default 192000)
     DCOffset
          DC Offset of signal (default 0)
     Width
          Width of sawtooth (default 1)
     OutputDataType
          Output data type of 'single' or 'double' (default 'double')

     Outputs
     .......

     OBJ - signalGenerator object

     Examples
     ........

     Create a 100 hz sine wave and plot first 512 samples
           sinosc = audioOscillator
           data = sinosc();
           plot(data);

     Create a 2 hz square wave with duty cycle of 0.5
           sqosc = audioOscillator('square', 'DutyCycle', 0.50,  'Frequency', 2);

 -- : DATA = OBJ()
     Generate a frame of waveform data from the generator function

     Inputs
     ......

     OBJ - signalGenerator object

     Outputs
     .......

     DATA - waveform data

 -- : release(OBJ)
     Release resources of generator

     Inputs
     ......

     OBJ - signalGenerator object

     Outputs
     .......

     None

3.6 Domain Conversion
=====================

3.6.1 bark2hz
-------------

 -- : HZ = bark2hz (BARK)
     Convert equivalent Bark Frequency to Hz.

     Inputs
     ......

     BARK - input frequency in bark.

     Outputs
     .......

     HZ - Output frequency in Hz.

     References
     ..........

     Traunmüller, Hartmut.  ‘Analytical Expressions for the Tonotopic
     Sensory Scale. Journal of the Acoustical Society of America. Vol.
     88, Issue 1, 1990’

     See also: hz2bark.

3.6.2 erb2hz
------------

 -- : HZ = erb2hz (ERB)
     Convert equivalent rectangular bandwidth (ERB) to Hz.

     Inputs
     ......

     ERB - input frequency in erb.

     Outputs
     .......

     HZ - Output frequency in Hz.

     References
     ..........

     Glasberg and Moore.  ‘Derivation of Auditory Filter Shapes from
     Notched-Noise Data. Hearing Research. Vol. 47, 1990’

     See also: hz2erb.

3.6.3 hz2bark
-------------

 -- : BARK = hz2bark (HZ)
     Convert hz to equivalent bark frequency

     Inputs
     ......

     HZ - input frequency in Hz.

     Outputs
     .......

     BARK - Output frequency as a bark value

     Examples
     ........

     Convert 4000 Hz to erb
          erb = hz2erb(4000)

     References
     ..........

     Traunmüller, Hartmut.  ‘Analytical Expressions for the Tonotopic
     Sensory Scale. Journal of the Acoustical Society of America. Vol.
     88, Issue 1, 1990’

     See also: bark2hz.

3.6.4 hz2erb
------------

 -- : ERB = hz2erb (HZ)
     Convert hz to equivalent rectangular bandwidth (ERB)

     Inputs
     ......

     HZ - input frequency in Hz.

     Outputs
     .......

     ERB - Output frequency as a erb value

     Examples
     ........

     Convert 4000 Hz to erb
          erb = hz2erb(4000)

     Convert a range of Hz to erb
          erb = hz2erb(4000:100:5000)

     References
     ..........

     Glasberg and Moore.  ‘Derivation of Auditory Filter Shapes from
     Notched-Noise Data. Hearing Research. Vol. 47, 1990’

     See also: erb2hz.

3.6.5 hz2mel
------------

 -- : MEL = hz2mel (HZ)
     Convert hz to equivalent mel frequency.

     Inputs
     ......

     HZ - input frequency in Hz.

     Outputs
     .......

     MEL - Output frequency as a mel value

     Examples
     ........

     Convert 4000 Hz to mel
          mel = hz2mel(4000)

     Convert a range of Hz to mel
          mel = hz2erb(4000:100:5000)

     References
     ..........

     O'Shaghnessy, Douglas.  ‘Speech Communication: Human and Machine.
     Reading, MA: Addison-Wesley Publishing Company, 1987’

     See also: mel2hz.

3.6.6 mel2hz
------------

 -- : HZ = mel2hz (MEL)
     Convert equivalent mel frequency to Hz.

     Inputs
     ......

     MEL - input frequency in mel.

     Outputs
     .......

     HZ - Output frequency in Hz.

     References
     ..........

     O'Shaghnessy, Douglas.  ‘Speech Communication: Human and Machine.
     Reading, MA: Addison-Wesley Publishing Company, 1987’

     See also: hz2mel.

3.6.7 phon2sone
---------------

 -- : SONE = phon2sone (PHON)
 -- : SONE = phon2sone (PHON, STANDARD)
     Convert from phon to sone

     Inputs
     ......

     PHON - Loudness level in phon

     STANDARD - Standard to use in conversion.  Options are 'ISO 532-1'
     or 'ISO 532-2'.

     'ISO 532-1' is used if no standard is provided.

     Outputs
     .......

     SONE - Loudness level in sone

     Examples
     ........

     Convert 100 phon to sone
          sone = phon2sone(100)

     References
     ..........

     International Organization for Standardization., ‘ISO 532-1
     Acoustics – Methods for calculating loudness – Part 1: Zwicker
     method.’

     International Organization for Standardization., ‘ISO 532-2
     Acoustics – Methods for calculating loudness – Part 2:
     Moore-Glasberg method.’

     https://sengpielaudio.com/calculatorSonephon.htm

     See also: sone2phon.

3.6.8 sone2phon
---------------

 -- : PHON = sone2phon (SONE)
 -- : PHON = sone2phon (SONE, STANDARD)
     Convert from sone to phon.

     Inputs
     ......

     SONE - Loudness level in sone

     STANDARD - Standard to use in conversion.  Options are 'ISO 532-1'
     or 'ISO 532-2'.

     'ISO 532-1' is used if no standard is provided.

     Outputs
     .......

     SONE - Loudness level in sone

     Examples
     ........

     Convert 100 sone to phon
          phon = sone2phon(100)

     References
     ..........

     International Organization for Standardization., ‘ISO 532-1
     Acoustics – Methods for calculating loudness – Part 1: Zwicker
     method.’

     International Organization for Standardization., ‘ISO 532-2
     Acoustics – Methods for calculating loudness – Part 2:
     Moore-Glasberg method.’

     https://sengpielaudio.com/calculatorSonephon.htm

     See also: sone2phon.

Appendix A GNU General Public License
*************************************

                        Version 3, 29 June 2007

     Copyright © 2007 Free Software Foundation, Inc. <http://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies of this
     license document, but changing it is not allowed.

Preamble
========

The GNU General Public License is a free, copyleft license for software
and other kinds of works.

The licenses for most software and other practical works are designed to
take away your freedom to share and change the works.  By contrast, the
GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users.  We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors.  You can apply it to
your programs, too.

When we speak of free software, we are referring to freedom, not price.
Our General Public Licenses are designed to make sure that you have the
freedom to distribute copies of free software (and charge for them if
you wish), that you receive source code or can get it if you want it,
that you can change the software or use pieces of it in new free
programs, and that you know you can do these things.

To protect your rights, we need to prevent others from denying you these
rights or asking you to surrender the rights.  Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.

For example, if you distribute copies of such a program, whether gratis
or for a fee, you must pass on to the recipients the same freedoms that
you received.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

Developers that use the GNU GPL protect your rights with two steps: (1)
assert copyright on the software, and (2) offer you this License giving
you legal permission to copy, distribute and/or modify it.

For the developers' and authors' protection, the GPL clearly explains
that there is no warranty for this free software.  For both users' and
authors' sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.

Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so.  This is fundamentally incompatible with the aim of
protecting users' freedom to change the software.  The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable.  Therefore, we
have designed this version of the GPL to prohibit the practice for those
products.  If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.

Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary.  To prevent this, the GPL assures that
patents cannot be used to render the program non-free.

The precise terms and conditions for copying, distribution and
modification follow.

TERMS AND CONDITIONS
====================

  0. Definitions.

     "This License" refers to version 3 of the GNU General Public
     License.

     "Copyright" also means copyright-like laws that apply to other
     kinds of works, such as semiconductor masks.

     "The Program" refers to any copyrightable work licensed under this
     License.  Each licensee is addressed as "you".  "Licensees" and
     "recipients" may be individuals or organizations.

     To "modify" a work means to copy from or adapt all or part of the
     work in a fashion requiring copyright permission, other than the
     making of an exact copy.  The resulting work is called a "modified
     version" of the earlier work or a work "based on" the earlier work.

     A "covered work" means either the unmodified Program or a work
     based on the Program.

     To "propagate" a work means to do anything with it that, without
     permission, would make you directly or secondarily liable for
     infringement under applicable copyright law, except executing it on
     a computer or modifying a private copy.  Propagation includes
     copying, distribution (with or without modification), making
     available to the public, and in some countries other activities as
     well.

     To "convey" a work means any kind of propagation that enables other
     parties to make or receive copies.  Mere interaction with a user
     through a computer network, with no transfer of a copy, is not
     conveying.

     An interactive user interface displays "Appropriate Legal Notices"
     to the extent that it includes a convenient and prominently visible
     feature that (1) displays an appropriate copyright notice, and (2)
     tells the user that there is no warranty for the work (except to
     the extent that warranties are provided), that licensees may convey
     the work under this License, and how to view a copy of this
     License.  If the interface presents a list of user commands or
     options, such as a menu, a prominent item in the list meets this
     criterion.

  1. Source Code.

     The "source code" for a work means the preferred form of the work
     for making modifications to it.  "Object code" means any non-source
     form of a work.

     A "Standard Interface" means an interface that either is an
     official standard defined by a recognized standards body, or, in
     the case of interfaces specified for a particular programming
     language, one that is widely used among developers working in that
     language.

     The "System Libraries" of an executable work include anything,
     other than the work as a whole, that (a) is included in the normal
     form of packaging a Major Component, but which is not part of that
     Major Component, and (b) serves only to enable use of the work with
     that Major Component, or to implement a Standard Interface for
     which an implementation is available to the public in source code
     form.  A "Major Component", in this context, means a major
     essential component (kernel, window system, and so on) of the
     specific operating system (if any) on which the executable work
     runs, or a compiler used to produce the work, or an object code
     interpreter used to run it.

     The "Corresponding Source" for a work in object code form means all
     the source code needed to generate, install, and (for an executable
     work) run the object code and to modify the work, including scripts
     to control those activities.  However, it does not include the
     work's System Libraries, or general-purpose tools or generally
     available free programs which are used unmodified in performing
     those activities but which are not part of the work.  For example,
     Corresponding Source includes interface definition files associated
     with source files for the work, and the source code for shared
     libraries and dynamically linked subprograms that the work is
     specifically designed to require, such as by intimate data
     communication or control flow between those subprograms and other
     parts of the work.

     The Corresponding Source need not include anything that users can
     regenerate automatically from other parts of the Corresponding
     Source.

     The Corresponding Source for a work in source code form is that
     same work.

  2. Basic Permissions.

     All rights granted under this License are granted for the term of
     copyright on the Program, and are irrevocable provided the stated
     conditions are met.  This License explicitly affirms your unlimited
     permission to run the unmodified Program.  The output from running
     a covered work is covered by this License only if the output, given
     its content, constitutes a covered work.  This License acknowledges
     your rights of fair use or other equivalent, as provided by
     copyright law.

     You may make, run and propagate covered works that you do not
     convey, without conditions so long as your license otherwise
     remains in force.  You may convey covered works to others for the
     sole purpose of having them make modifications exclusively for you,
     or provide you with facilities for running those works, provided
     that you comply with the terms of this License in conveying all
     material for which you do not control copyright.  Those thus making
     or running the covered works for you must do so exclusively on your
     behalf, under your direction and control, on terms that prohibit
     them from making any copies of your copyrighted material outside
     their relationship with you.

     Conveying under any other circumstances is permitted solely under
     the conditions stated below.  Sublicensing is not allowed; section
     10 makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

     No covered work shall be deemed part of an effective technological
     measure under any applicable law fulfilling obligations under
     article 11 of the WIPO copyright treaty adopted on 20 December
     1996, or similar laws prohibiting or restricting circumvention of
     such measures.

     When you convey a covered work, you waive any legal power to forbid
     circumvention of technological measures to the extent such
     circumvention is effected by exercising rights under this License
     with respect to the covered work, and you disclaim any intention to
     limit operation or modification of the work as a means of
     enforcing, against the work's users, your or third parties' legal
     rights to forbid circumvention of technological measures.

  4. Conveying Verbatim Copies.

     You may convey verbatim copies of the Program's source code as you
     receive it, in any medium, provided that you conspicuously and
     appropriately publish on each copy an appropriate copyright notice;
     keep intact all notices stating that this License and any
     non-permissive terms added in accord with section 7 apply to the
     code; keep intact all notices of the absence of any warranty; and
     give all recipients a copy of this License along with the Program.

     You may charge any price or no price for each copy that you convey,
     and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

     You may convey a work based on the Program, or the modifications to
     produce it from the Program, in the form of source code under the
     terms of section 4, provided that you also meet all of these
     conditions:

       a. The work must carry prominent notices stating that you
          modified it, and giving a relevant date.

       b. The work must carry prominent notices stating that it is
          released under this License and any conditions added under
          section 7.  This requirement modifies the requirement in
          section 4 to "keep intact all notices".

       c. You must license the entire work, as a whole, under this
          License to anyone who comes into possession of a copy.  This
          License will therefore apply, along with any applicable
          section 7 additional terms, to the whole of the work, and all
          its parts, regardless of how they are packaged.  This License
          gives no permission to license the work in any other way, but
          it does not invalidate such permission if you have separately
          received it.

       d. If the work has interactive user interfaces, each must display
          Appropriate Legal Notices; however, if the Program has
          interactive interfaces that do not display Appropriate Legal
          Notices, your work need not make them do so.

     A compilation of a covered work with other separate and independent
     works, which are not by their nature extensions of the covered
     work, and which are not combined with it such as to form a larger
     program, in or on a volume of a storage or distribution medium, is
     called an "aggregate" if the compilation and its resulting
     copyright are not used to limit the access or legal rights of the
     compilation's users beyond what the individual works permit.
     Inclusion of a covered work in an aggregate does not cause this
     License to apply to the other parts of the aggregate.

  6. Conveying Non-Source Forms.

     You may convey a covered work in object code form under the terms
     of sections 4 and 5, provided that you also convey the
     machine-readable Corresponding Source under the terms of this
     License, in one of these ways:

       a. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by the
          Corresponding Source fixed on a durable physical medium
          customarily used for software interchange.

       b. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by a
          written offer, valid for at least three years and valid for as
          long as you offer spare parts or customer support for that
          product model, to give anyone who possesses the object code
          either (1) a copy of the Corresponding Source for all the
          software in the product that is covered by this License, on a
          durable physical medium customarily used for software
          interchange, for a price no more than your reasonable cost of
          physically performing this conveying of source, or (2) access
          to copy the Corresponding Source from a network server at no
          charge.

       c. Convey individual copies of the object code with a copy of the
          written offer to provide the Corresponding Source.  This
          alternative is allowed only occasionally and noncommercially,
          and only if you received the object code with such an offer,
          in accord with subsection 6b.

       d. Convey the object code by offering access from a designated
          place (gratis or for a charge), and offer equivalent access to
          the Corresponding Source in the same way through the same
          place at no further charge.  You need not require recipients
          to copy the Corresponding Source along with the object code.
          If the place to copy the object code is a network server, the
          Corresponding Source may be on a different server (operated by
          you or a third party) that supports equivalent copying
          facilities, provided you maintain clear directions next to the
          object code saying where to find the Corresponding Source.
          Regardless of what server hosts the Corresponding Source, you
          remain obligated to ensure that it is available for as long as
          needed to satisfy these requirements.

       e. Convey the object code using peer-to-peer transmission,
          provided you inform other peers where the object code and
          Corresponding Source of the work are being offered to the
          general public at no charge under subsection 6d.

     A separable portion of the object code, whose source code is
     excluded from the Corresponding Source as a System Library, need
     not be included in conveying the object code work.

     A "User Product" is either (1) a "consumer product", which means
     any tangible personal property which is normally used for personal,
     family, or household purposes, or (2) anything designed or sold for
     incorporation into a dwelling.  In determining whether a product is
     a consumer product, doubtful cases shall be resolved in favor of
     coverage.  For a particular product received by a particular user,
     "normally used" refers to a typical or common use of that class of
     product, regardless of the status of the particular user or of the
     way in which the particular user actually uses, or expects or is
     expected to use, the product.  A product is a consumer product
     regardless of whether the product has substantial commercial,
     industrial or non-consumer uses, unless such uses represent the
     only significant mode of use of the product.

     "Installation Information" for a User Product means any methods,
     procedures, authorization keys, or other information required to
     install and execute modified versions of a covered work in that
     User Product from a modified version of its Corresponding Source.
     The information must suffice to ensure that the continued
     functioning of the modified object code is in no case prevented or
     interfered with solely because modification has been made.

     If you convey an object code work under this section in, or with,
     or specifically for use in, a User Product, and the conveying
     occurs as part of a transaction in which the right of possession
     and use of the User Product is transferred to the recipient in
     perpetuity or for a fixed term (regardless of how the transaction
     is characterized), the Corresponding Source conveyed under this
     section must be accompanied by the Installation Information.  But
     this requirement does not apply if neither you nor any third party
     retains the ability to install modified object code on the User
     Product (for example, the work has been installed in ROM).

     The requirement to provide Installation Information does not
     include a requirement to continue to provide support service,
     warranty, or updates for a work that has been modified or installed
     by the recipient, or for the User Product in which it has been
     modified or installed.  Access to a network may be denied when the
     modification itself materially and adversely affects the operation
     of the network or violates the rules and protocols for
     communication across the network.

     Corresponding Source conveyed, and Installation Information
     provided, in accord with this section must be in a format that is
     publicly documented (and with an implementation available to the
     public in source code form), and must require no special password
     or key for unpacking, reading or copying.

  7. Additional Terms.

     "Additional permissions" are terms that supplement the terms of
     this License by making exceptions from one or more of its
     conditions.  Additional permissions that are applicable to the
     entire Program shall be treated as though they were included in
     this License, to the extent that they are valid under applicable
     law.  If additional permissions apply only to part of the Program,
     that part may be used separately under those permissions, but the
     entire Program remains governed by this License without regard to
     the additional permissions.

     When you convey a copy of a covered work, you may at your option
     remove any additional permissions from that copy, or from any part
     of it.  (Additional permissions may be written to require their own
     removal in certain cases when you modify the work.)  You may place
     additional permissions on material, added by you to a covered work,
     for which you have or can give appropriate copyright permission.

     Notwithstanding any other provision of this License, for material
     you add to a covered work, you may (if authorized by the copyright
     holders of that material) supplement the terms of this License with
     terms:

       a. Disclaiming warranty or limiting liability differently from
          the terms of sections 15 and 16 of this License; or

       b. Requiring preservation of specified reasonable legal notices
          or author attributions in that material or in the Appropriate
          Legal Notices displayed by works containing it; or

       c. Prohibiting misrepresentation of the origin of that material,
          or requiring that modified versions of such material be marked
          in reasonable ways as different from the original version; or

       d. Limiting the use for publicity purposes of names of licensors
          or authors of the material; or

       e. Declining to grant rights under trademark law for use of some
          trade names, trademarks, or service marks; or

       f. Requiring indemnification of licensors and authors of that
          material by anyone who conveys the material (or modified
          versions of it) with contractual assumptions of liability to
          the recipient, for any liability that these contractual
          assumptions directly impose on those licensors and authors.

     All other non-permissive additional terms are considered "further
     restrictions" within the meaning of section 10.  If the Program as
     you received it, or any part of it, contains a notice stating that
     it is governed by this License along with a term that is a further
     restriction, you may remove that term.  If a license document
     contains a further restriction but permits relicensing or conveying
     under this License, you may add to a covered work material governed
     by the terms of that license document, provided that the further
     restriction does not survive such relicensing or conveying.

     If you add terms to a covered work in accord with this section, you
     must place, in the relevant source files, a statement of the
     additional terms that apply to those files, or a notice indicating
     where to find the applicable terms.

     Additional terms, permissive or non-permissive, may be stated in
     the form of a separately written license, or stated as exceptions;
     the above requirements apply either way.

  8. Termination.

     You may not propagate or modify a covered work except as expressly
     provided under this License.  Any attempt otherwise to propagate or
     modify it is void, and will automatically terminate your rights
     under this License (including any patent licenses granted under the
     third paragraph of section 11).

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, you do not qualify to receive new licenses
     for the same material under section 10.

  9. Acceptance Not Required for Having Copies.

     You are not required to accept this License in order to receive or
     run a copy of the Program.  Ancillary propagation of a covered work
     occurring solely as a consequence of using peer-to-peer
     transmission to receive a copy likewise does not require
     acceptance.  However, nothing other than this License grants you
     permission to propagate or modify any covered work.  These actions
     infringe copyright if you do not accept this License.  Therefore,
     by modifying or propagating a covered work, you indicate your
     acceptance of this License to do so.

  10. Automatic Licensing of Downstream Recipients.

     Each time you convey a covered work, the recipient automatically
     receives a license from the original licensors, to run, modify and
     propagate that work, subject to this License.  You are not
     responsible for enforcing compliance by third parties with this
     License.

     An "entity transaction" is a transaction transferring control of an
     organization, or substantially all assets of one, or subdividing an
     organization, or merging organizations.  If propagation of a
     covered work results from an entity transaction, each party to that
     transaction who receives a copy of the work also receives whatever
     licenses to the work the party's predecessor in interest had or
     could give under the previous paragraph, plus a right to possession
     of the Corresponding Source of the work from the predecessor in
     interest, if the predecessor has it or can get it with reasonable
     efforts.

     You may not impose any further restrictions on the exercise of the
     rights granted or affirmed under this License.  For example, you
     may not impose a license fee, royalty, or other charge for exercise
     of rights granted under this License, and you may not initiate
     litigation (including a cross-claim or counterclaim in a lawsuit)
     alleging that any patent claim is infringed by making, using,
     selling, offering for sale, or importing the Program or any portion
     of it.

  11. Patents.

     A "contributor" is a copyright holder who authorizes use under this
     License of the Program or a work on which the Program is based.
     The work thus licensed is called the contributor's "contributor
     version".

     A contributor's "essential patent claims" are all patent claims
     owned or controlled by the contributor, whether already acquired or
     hereafter acquired, that would be infringed by some manner,
     permitted by this License, of making, using, or selling its
     contributor version, but do not include claims that would be
     infringed only as a consequence of further modification of the
     contributor version.  For purposes of this definition, "control"
     includes the right to grant patent sublicenses in a manner
     consistent with the requirements of this License.

     Each contributor grants you a non-exclusive, worldwide,
     royalty-free patent license under the contributor's essential
     patent claims, to make, use, sell, offer for sale, import and
     otherwise run, modify and propagate the contents of its contributor
     version.

     In the following three paragraphs, a "patent license" is any
     express agreement or commitment, however denominated, not to
     enforce a patent (such as an express permission to practice a
     patent or covenant not to sue for patent infringement).  To "grant"
     such a patent license to a party means to make such an agreement or
     commitment not to enforce a patent against the party.

     If you convey a covered work, knowingly relying on a patent
     license, and the Corresponding Source of the work is not available
     for anyone to copy, free of charge and under the terms of this
     License, through a publicly available network server or other
     readily accessible means, then you must either (1) cause the
     Corresponding Source to be so available, or (2) arrange to deprive
     yourself of the benefit of the patent license for this particular
     work, or (3) arrange, in a manner consistent with the requirements
     of this License, to extend the patent license to downstream
     recipients.  "Knowingly relying" means you have actual knowledge
     that, but for the patent license, your conveying the covered work
     in a country, or your recipient's use of the covered work in a
     country, would infringe one or more identifiable patents in that
     country that you have reason to believe are valid.

     If, pursuant to or in connection with a single transaction or
     arrangement, you convey, or propagate by procuring conveyance of, a
     covered work, and grant a patent license to some of the parties
     receiving the covered work authorizing them to use, propagate,
     modify or convey a specific copy of the covered work, then the
     patent license you grant is automatically extended to all
     recipients of the covered work and works based on it.

     A patent license is "discriminatory" if it does not include within
     the scope of its coverage, prohibits the exercise of, or is
     conditioned on the non-exercise of one or more of the rights that
     are specifically granted under this License.  You may not convey a
     covered work if you are a party to an arrangement with a third
     party that is in the business of distributing software, under which
     you make payment to the third party based on the extent of your
     activity of conveying the work, and under which the third party
     grants, to any of the parties who would receive the covered work
     from you, a discriminatory patent license (a) in connection with
     copies of the covered work conveyed by you (or copies made from
     those copies), or (b) primarily for and in connection with specific
     products or compilations that contain the covered work, unless you
     entered into that arrangement, or that patent license was granted,
     prior to 28 March 2007.

     Nothing in this License shall be construed as excluding or limiting
     any implied license or other defenses to infringement that may
     otherwise be available to you under applicable patent law.

  12. No Surrender of Others' Freedom.

     If conditions are imposed on you (whether by court order, agreement
     or otherwise) that contradict the conditions of this License, they
     do not excuse you from the conditions of this License.  If you
     cannot convey a covered work so as to satisfy simultaneously your
     obligations under this License and any other pertinent obligations,
     then as a consequence you may not convey it at all.  For example,
     if you agree to terms that obligate you to collect a royalty for
     further conveying from those to whom you convey the Program, the
     only way you could satisfy both those terms and this License would
     be to refrain entirely from conveying the Program.

  13. Use with the GNU Affero General Public License.

     Notwithstanding any other provision of this License, you have
     permission to link or combine any covered work with a work licensed
     under version 3 of the GNU Affero General Public License into a
     single combined work, and to convey the resulting work.  The terms
     of this License will continue to apply to the part which is the
     covered work, but the special requirements of the GNU Affero
     General Public License, section 13, concerning interaction through
     a network will apply to the combination as such.

  14. Revised Versions of this License.

     The Free Software Foundation may publish revised and/or new
     versions of the GNU General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies that a certain numbered version of the GNU
     General Public License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that numbered version or of any later version published by the Free
     Software Foundation.  If the Program does not specify a version
     number of the GNU General Public License, you may choose any
     version ever published by the Free Software Foundation.

     If the Program specifies that a proxy can decide which future
     versions of the GNU General Public License can be used, that
     proxy's public statement of acceptance of a version permanently
     authorizes you to choose that version for the Program.

     Later license versions may give you additional or different
     permissions.  However, no additional obligations are imposed on any
     author or copyright holder as a result of your choosing to follow a
     later version.

  15. Disclaimer of Warranty.

     THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
     APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS"
     WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE
     RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
     SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
     NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. Limitation of Liability.

     IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
     AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR
     DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF
     THE POSSIBILITY OF SUCH DAMAGES.

  17. Interpretation of Sections 15 and 16.

     If the disclaimer of warranty and limitation of liability provided
     above cannot be given local legal effect according to their terms,
     reviewing courts shall apply local law that most closely
     approximates an absolute waiver of all civil liability in
     connection with the Program, unless a warranty or assumption of
     liability accompanies a copy of the Program in return for a fee.

END OF TERMS AND CONDITIONS
===========================

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

To do so, attach the following notices to the program.  It is safest to
attach them to the start of each source file to most effectively state
the exclusion of warranty; and each file should have at least the
"copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND A BRIEF IDEA OF WHAT IT DOES.
     Copyright (C) YEAR NAME OF AUTHOR

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, either version 3 of the License, or (at
     your option) any later version.

     This program is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

If the program does terminal interaction, make it output a short notice
like this when it starts in an interactive mode:

     PROGRAM Copyright (C) YEAR NAME OF AUTHOR
     This program comes with ABSOLUTELY NO WARRANTY; for details type ‘show w’.
     This is free software, and you are welcome to redistribute it
     under certain conditions; type ‘show c’ for details.

The hypothetical commands ‘show w’ and ‘show c’ should show the
appropriate parts of the General Public License.  Of course, your
program's commands might be different; for a GUI interface, you would
use an "about box".

You should also get your employer (if you work as a programmer) or
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  For more information on this, and how to apply and follow
the GNU GPL, see <http://www.gnu.org/licenses/>.

The GNU General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Lesser General Public License instead of this License.  But first,
please read <http://www.gnu.org/philosophy/why-not-lgpl.html>.